#pragma once

// AUTOGENERATED
// /home/duser/dev/MK5/software/build/mk5-bin/stack/src/fac-1609/j2735/DSRC_R70_Source.ASN
//     to
// /home/duser/dev/MK5/software/build/mk5-bin/stack/src/fac-1609/j2735/gen/j2735asn*

#ifdef __cplusplus
extern "C"
{
#endif
// with prefix 'SAE'


// SAEAccelerationConfidence_Limit
#define SAEAccelerationConfidence_Limit_Min                                             0
#define SAEAccelerationConfidence_Limit_Max                                             7

// SAEAcceleration_Limit
#define SAEAcceleration_Limit_Min                                                       -2000
#define SAEAcceleration_Limit_Max                                                       2001

// SAEAddGrpB_Angle_Limit
#define SAEAddGrpB_Angle_Limit_Min                                                      0
#define SAEAddGrpB_Angle_Limit_Max                                                      239

// SAEAddGrpB_Elevation_Limit
#define SAEAddGrpB_Elevation_Limit_Min                                                  -32768
#define SAEAddGrpB_Elevation_Limit_Max                                                  32767

// SAEAddGrpB_MsgCount_Limit
#define SAEAddGrpB_MsgCount_Limit_Min                                                   0
#define SAEAddGrpB_MsgCount_Limit_Max                                                   255

// SAEAdvisorySpeedList_SeqSize
#define SAEAdvisorySpeedList_SeqSize_Min                                                1
#define SAEAdvisorySpeedList_SeqSize_Max                                                16

// SAEAdvisorySpeedType_Limit
#define SAEAdvisorySpeedType_Limit_Min                                                  0
#define SAEAdvisorySpeedType_Limit_Max                                                  3

// SAEAllowedManeuvers
#define SAEAllowedManeuvers_maneuverStraightAllowed                                     0
#define SAEAllowedManeuvers_maneuverLeftAllowed                                         1
#define SAEAllowedManeuvers_maneuverRightAllowed                                        2
#define SAEAllowedManeuvers_maneuverUTurnAllowed                                        3
#define SAEAllowedManeuvers_maneuverLeftTurnOnRedAllowed                                4
#define SAEAllowedManeuvers_maneuverRightTurnOnRedAllowed                               5
#define SAEAllowedManeuvers_maneuverLaneChangeAllowed                                   6
#define SAEAllowedManeuvers_maneuverNoStoppingAllowed                                   7
#define SAEAllowedManeuvers_yieldAllwaysRequired                                        8
#define SAEAllowedManeuvers_goWithHalt                                                  9
#define SAEAllowedManeuvers_caution                                                     10
#define SAEAllowedManeuvers_reserved1                                                   11
#define SAEAllowedManeuvers_NumBits                                                     12

// SAEAltitudeValue_Limit
#define SAEAltitudeValue_Limit_Min                                                      -100000
#define SAEAltitudeValue_Limit_Max                                                      800001

// SAEAmbientAirPressure_Limit
#define SAEAmbientAirPressure_Limit_Min                                                 0
#define SAEAmbientAirPressure_Limit_Max                                                 255

// SAEAmbientAirTemperature_Limit
#define SAEAmbientAirTemperature_Limit_Min                                              0
#define SAEAmbientAirTemperature_Limit_Max                                              191

// SAEAngle_Limit
#define SAEAngle_Limit_Min                                                              0
#define SAEAngle_Limit_Max                                                              28800

// SAEAnimalPropelledType_Limit
#define SAEAnimalPropelledType_Limit_Min                                                0
#define SAEAnimalPropelledType_Limit_Max                                                3

// SAEAnimalType_Limit
#define SAEAnimalType_Limit_Min                                                         0
#define SAEAnimalType_Limit_Max                                                         3

// SAEAntiLockBrakeStatus_Limit
#define SAEAntiLockBrakeStatus_Limit_Min                                                0
#define SAEAntiLockBrakeStatus_Limit_Max                                                3

// SAEApproachID_Limit
#define SAEApproachID_Limit_Min                                                         0
#define SAEApproachID_Limit_Max                                                         15

// SAEAttachmentRadius_Limit
#define SAEAttachmentRadius_Limit_Min                                                   0
#define SAEAttachmentRadius_Limit_Max                                                   200

// SAEAttachment_Limit
#define SAEAttachment_Limit_Min                                                         0
#define SAEAttachment_Limit_Max                                                         6

// SAEAuxiliaryBrakeStatus_Limit
#define SAEAuxiliaryBrakeStatus_Limit_Min                                               0
#define SAEAuxiliaryBrakeStatus_Limit_Max                                               3

// SAEAxleLocation_Limit
#define SAEAxleLocation_Limit_Min                                                       0
#define SAEAxleLocation_Limit_Max                                                       255

// SAEAxleWeightList_SeqSize
#define SAEAxleWeightList_SeqSize_Min                                                   1
#define SAEAxleWeightList_SeqSize_Max                                                   16

// SAEAxleWeight_Limit
#define SAEAxleWeight_Limit_Min                                                         0
#define SAEAxleWeight_Limit_Max                                                         64255

// SAEBasicVehicleClass
#define SAEBasicVehicleClass_unknownVehicleClass                                        0
#define SAEBasicVehicleClass_specialVehicleClass                                        1
#define SAEBasicVehicleClass_passenger_Vehicle_TypeUnknown                              10
#define SAEBasicVehicleClass_passenger_Vehicle_TypeOther                                11
#define SAEBasicVehicleClass_lightTruck_Vehicle_TypeUnknown                             20
#define SAEBasicVehicleClass_lightTruck_Vehicle_TypeOther                               21
#define SAEBasicVehicleClass_truck_Vehicle_TypeUnknown                                  25
#define SAEBasicVehicleClass_truck_Vehicle_TypeOther                                    26
#define SAEBasicVehicleClass_truck_axleCnt2                                             27
#define SAEBasicVehicleClass_truck_axleCnt3                                             28
#define SAEBasicVehicleClass_truck_axleCnt4                                             29
#define SAEBasicVehicleClass_truck_axleCnt4Trailer                                      30
#define SAEBasicVehicleClass_truck_axleCnt5Trailer                                      31
#define SAEBasicVehicleClass_truck_axleCnt6Trailer                                      32
#define SAEBasicVehicleClass_truck_axleCnt5MultiTrailer                                 33
#define SAEBasicVehicleClass_truck_axleCnt6MultiTrailer                                 34
#define SAEBasicVehicleClass_truck_axleCnt7MultiTrailer                                 35
#define SAEBasicVehicleClass_motorcycle_TypeUnknown                                     40
#define SAEBasicVehicleClass_motorcycle_TypeOther                                       41
#define SAEBasicVehicleClass_motorcycle_Cruiser_Standard                                42
#define SAEBasicVehicleClass_motorcycle_SportUnclad                                     43
#define SAEBasicVehicleClass_motorcycle_SportTouring                                    44
#define SAEBasicVehicleClass_motorcycle_SuperSport                                      45
#define SAEBasicVehicleClass_motorcycle_Touring                                         46
#define SAEBasicVehicleClass_motorcycle_Trike                                           47
#define SAEBasicVehicleClass_motorcycle_wPassengers                                     48
#define SAEBasicVehicleClass_transit_TypeUnknown                                        50
#define SAEBasicVehicleClass_transit_TypeOther                                          51
#define SAEBasicVehicleClass_transit_BRT                                                52
#define SAEBasicVehicleClass_transit_ExpressBus                                         53
#define SAEBasicVehicleClass_transit_LocalBus                                           54
#define SAEBasicVehicleClass_transit_SchoolBus                                          55
#define SAEBasicVehicleClass_transit_FixedGuideway                                      56
#define SAEBasicVehicleClass_transit_Paratransit                                        57
#define SAEBasicVehicleClass_transit_Paratransit_Ambulance                              58
#define SAEBasicVehicleClass_emergency_TypeUnknown                                      60
#define SAEBasicVehicleClass_emergency_TypeOther                                        61
#define SAEBasicVehicleClass_emergency_Fire_Light_Vehicle                               62
#define SAEBasicVehicleClass_emergency_Fire_Heavy_Vehicle                               63
#define SAEBasicVehicleClass_emergency_Fire_Paramedic_Vehicle                           64
#define SAEBasicVehicleClass_emergency_Fire_Ambulance_Vehicle                           65
#define SAEBasicVehicleClass_emergency_Police_Light_Vehicle                             66
#define SAEBasicVehicleClass_emergency_Police_Heavy_Vehicle                             67
#define SAEBasicVehicleClass_emergency_Other_Responder                                  68
#define SAEBasicVehicleClass_emergency_Other_Ambulance                                  69
#define SAEBasicVehicleClass_otherTraveler_TypeUnknown                                  80
#define SAEBasicVehicleClass_otherTraveler_TypeOther                                    81
#define SAEBasicVehicleClass_otherTraveler_Pedestrian                                   82
#define SAEBasicVehicleClass_otherTraveler_Visually_Disabled                            83
#define SAEBasicVehicleClass_otherTraveler_Physically_Disabled                          84
#define SAEBasicVehicleClass_otherTraveler_Bicycle                                      85
#define SAEBasicVehicleClass_otherTraveler_Vulnerable_Roadworker                        86
#define SAEBasicVehicleClass_infrastructure_TypeUnknown                                 90
#define SAEBasicVehicleClass_infrastructure_Fixed                                       91
#define SAEBasicVehicleClass_infrastructure_Movable                                     92
#define SAEBasicVehicleClass_equipped_CargoTrailer                                      93

// SAEBasicVehicleClass_Limit
#define SAEBasicVehicleClass_Limit_Min                                                  0
#define SAEBasicVehicleClass_Limit_Max                                                  255

// SAEBasicVehicleRole_Limit
#define SAEBasicVehicleRole_Limit_Min                                                   0
#define SAEBasicVehicleRole_Limit_Max                                                   22

// SAEBrakeAppliedPressure_Limit
#define SAEBrakeAppliedPressure_Limit_Min                                               0
#define SAEBrakeAppliedPressure_Limit_Max                                               15

// SAEBrakeAppliedStatus
#define SAEBrakeAppliedStatus_unavailable                                               0
#define SAEBrakeAppliedStatus_leftFront                                                 1
#define SAEBrakeAppliedStatus_leftRear                                                  2
#define SAEBrakeAppliedStatus_rightFront                                                3
#define SAEBrakeAppliedStatus_rightRear                                                 4
#define SAEBrakeAppliedStatus_NumBits                                                   5

// SAEBrakeBoostApplied_Limit
#define SAEBrakeBoostApplied_Limit_Min                                                  0
#define SAEBrakeBoostApplied_Limit_Max                                                  2

// SAEBumperHeight_Limit
#define SAEBumperHeight_Limit_Min                                                       0
#define SAEBumperHeight_Limit_Max                                                       127

// SAECargoWeight_Limit
#define SAECargoWeight_Limit_Min                                                        0
#define SAECargoWeight_Limit_Max                                                        64255

// SAECoarseHeading_Limit
#define SAECoarseHeading_Limit_Min                                                      0
#define SAECoarseHeading_Limit_Max                                                      240

// SAECodeWord
#define SAECodeWord_NumOctets                                                           16

// SAECoefficientOfFriction_Limit
#define SAECoefficientOfFriction_Limit_Min                                              0
#define SAECoefficientOfFriction_Limit_Max                                              50

// SAEConfidence_Limit
#define SAEConfidence_Limit_Min                                                         0
#define SAEConfidence_Limit_Max                                                         200

// SAEConnectsToList_SeqSize
#define SAEConnectsToList_SeqSize_Min                                                   1
#define SAEConnectsToList_SeqSize_Max                                                   16

// SAECount_Limit
#define SAECount_Limit_Min                                                              0
#define SAECount_Limit_Max                                                              32

// SAEDDay_Limit
#define SAEDDay_Limit_Min                                                               0
#define SAEDDay_Limit_Max                                                               31

// SAEDHour_Limit
#define SAEDHour_Limit_Min                                                              0
#define SAEDHour_Limit_Max                                                              31

// SAEDMinute_Limit
#define SAEDMinute_Limit_Min                                                            0
#define SAEDMinute_Limit_Max                                                            60

// SAEDMonth_Limit
#define SAEDMonth_Limit_Min                                                             0
#define SAEDMonth_Limit_Max                                                             12

// SAEDOffset_Limit
#define SAEDOffset_Limit_Min                                                            -840
#define SAEDOffset_Limit_Max                                                            840

// SAEDSRCmsgID
#define SAEDSRCmsgID_reservedMessageId_D                                                0
#define SAEDSRCmsgID_alaCarteMessage_D                                                  1
#define SAEDSRCmsgID_basicSafetyMessage_D                                               2
#define SAEDSRCmsgID_basicSafetyMessageVerbose_D                                        3
#define SAEDSRCmsgID_commonSafetyRequest_D                                              4
#define SAEDSRCmsgID_emergencyVehicleAlert_D                                            5
#define SAEDSRCmsgID_intersectionCollision_D                                            6
#define SAEDSRCmsgID_mapData_D                                                          7
#define SAEDSRCmsgID_nmeaCorrections_D                                                  8
#define SAEDSRCmsgID_probeDataManagement_D                                              9
#define SAEDSRCmsgID_probeVehicleData_D                                                 10
#define SAEDSRCmsgID_roadSideAlert_D                                                    11
#define SAEDSRCmsgID_rtcmCorrections_D                                                  12
#define SAEDSRCmsgID_signalPhaseAndTimingMessage_D                                      13
#define SAEDSRCmsgID_signalRequestMessage_D                                             14
#define SAEDSRCmsgID_signalStatusMessage_D                                              15
#define SAEDSRCmsgID_travelerInformation_D                                              16
#define SAEDSRCmsgID_uperFrame_D                                                        17
#define SAEDSRCmsgID_mapData                                                            18
#define SAEDSRCmsgID_signalPhaseAndTimingMessage                                        19
#define SAEDSRCmsgID_basicSafetyMessage                                                 20
#define SAEDSRCmsgID_commonSafetyRequest                                                21
#define SAEDSRCmsgID_emergencyVehicleAlert                                              22
#define SAEDSRCmsgID_intersectionCollision                                              23
#define SAEDSRCmsgID_nmeaCorrections                                                    24
#define SAEDSRCmsgID_probeDataManagement                                                25
#define SAEDSRCmsgID_probeVehicleData                                                   26
#define SAEDSRCmsgID_roadSideAlert                                                      27
#define SAEDSRCmsgID_rtcmCorrections                                                    28
#define SAEDSRCmsgID_signalRequestMessage                                               29
#define SAEDSRCmsgID_signalStatusMessage                                                30
#define SAEDSRCmsgID_travelerInformation                                                31
#define SAEDSRCmsgID_personalSafetyMessage                                              32
#define SAEDSRCmsgID_testMessage00                                                      240
#define SAEDSRCmsgID_testMessage01                                                      241
#define SAEDSRCmsgID_testMessage02                                                      242
#define SAEDSRCmsgID_testMessage03                                                      243
#define SAEDSRCmsgID_testMessage04                                                      244
#define SAEDSRCmsgID_testMessage05                                                      245
#define SAEDSRCmsgID_testMessage06                                                      246
#define SAEDSRCmsgID_testMessage07                                                      247
#define SAEDSRCmsgID_testMessage08                                                      248
#define SAEDSRCmsgID_testMessage09                                                      249
#define SAEDSRCmsgID_testMessage10                                                      250
#define SAEDSRCmsgID_testMessage11                                                      251
#define SAEDSRCmsgID_testMessage12                                                      252
#define SAEDSRCmsgID_testMessage13                                                      253
#define SAEDSRCmsgID_testMessage14                                                      254
#define SAEDSRCmsgID_testMessage15                                                      255

// SAEDSRCmsgID_Limit
#define SAEDSRCmsgID_Limit_Min                                                          0
#define SAEDSRCmsgID_Limit_Max                                                          32767

// SAEDSecond_Limit
#define SAEDSecond_Limit_Min                                                            0
#define SAEDSecond_Limit_Max                                                            65535

// SAEDYear_Limit
#define SAEDYear_Limit_Min                                                              0
#define SAEDYear_Limit_Max                                                              4095

// SAEDayOfWeek_Limit
#define SAEDayOfWeek_Limit_Min                                                          0
#define SAEDayOfWeek_Limit_Max                                                          7

// SAEDay_Limit
#define SAEDay_Limit_Min                                                                0
#define SAEDay_Limit_Max                                                                255

// SAEDegreesLat_Limit
#define SAEDegreesLat_Limit_Min                                                         -90
#define SAEDegreesLat_Limit_Max                                                         90

// SAEDegreesLong_Limit
#define SAEDegreesLong_Limit_Min                                                        -180
#define SAEDegreesLong_Limit_Max                                                        180

// SAEDeltaAngle_Limit
#define SAEDeltaAngle_Limit_Min                                                         -150
#define SAEDeltaAngle_Limit_Max                                                         150

// SAEDeltaTime_Limit
#define SAEDeltaTime_Limit_Min                                                          -122
#define SAEDeltaTime_Limit_Max                                                          121

// SAEDescriptiveName
#define SAEDescriptiveName_NumOctets                                                    63

// SAEDirectionOfUse_Limit
#define SAEDirectionOfUse_Limit_Min                                                     0
#define SAEDirectionOfUse_Limit_Max                                                     3

// SAEDistanceUnits_Limit
#define SAEDistanceUnits_Limit_Min                                                      0
#define SAEDistanceUnits_Limit_Max                                                      7

// SAEDriveAxleLiftAirPressure_Limit
#define SAEDriveAxleLiftAirPressure_Limit_Min                                           0
#define SAEDriveAxleLiftAirPressure_Limit_Max                                           1000

// SAEDriveAxleLocation_Limit
#define SAEDriveAxleLocation_Limit_Min                                                  0
#define SAEDriveAxleLocation_Limit_Max                                                  255

// SAEDriveAxleLubePressure_Limit
#define SAEDriveAxleLubePressure_Limit_Min                                              0
#define SAEDriveAxleLubePressure_Limit_Max                                              250

// SAEDriveAxleTemperature_Limit
#define SAEDriveAxleTemperature_Limit_Min                                               -40
#define SAEDriveAxleTemperature_Limit_Max                                               210

// SAEDrivenLineOffsetLg_Limit
#define SAEDrivenLineOffsetLg_Limit_Min                                                 -32767
#define SAEDrivenLineOffsetLg_Limit_Max                                                 32767

// SAEDrivenLineOffsetSm_Limit
#define SAEDrivenLineOffsetSm_Limit_Min                                                 -2047
#define SAEDrivenLineOffsetSm_Limit_Max                                                 2047

// SAEDrivingWheelAngle_Limit
#define SAEDrivingWheelAngle_Limit_Min                                                  -128
#define SAEDrivingWheelAngle_Limit_Max                                                  127

// SAEDuration_Limit
#define SAEDuration_Limit_Min                                                           0
#define SAEDuration_Limit_Max                                                           3600

// SAEElevationConfidence_Limit
#define SAEElevationConfidence_Limit_Min                                                0
#define SAEElevationConfidence_Limit_Max                                                15

// SAEElevation_Limit
#define SAEElevation_Limit_Min                                                          -4096
#define SAEElevation_Limit_Max                                                          61439

// SAEEnabledLaneList_SeqSize
#define SAEEnabledLaneList_SeqSize_Min                                                  1
#define SAEEnabledLaneList_SeqSize_Max                                                  16

// SAEEssMobileFriction_Limit
#define SAEEssMobileFriction_Limit_Min                                                  0
#define SAEEssMobileFriction_Limit_Max                                                  101

// SAEEssPrecipRate_Limit
#define SAEEssPrecipRate_Limit_Min                                                      0
#define SAEEssPrecipRate_Limit_Max                                                      65535

// SAEEssPrecipSituation_Limit
#define SAEEssPrecipSituation_Limit_Min                                                 1
#define SAEEssPrecipSituation_Limit_Max                                                 15

// SAEEssPrecipYesNo_Limit
#define SAEEssPrecipYesNo_Limit_Min                                                     1
#define SAEEssPrecipYesNo_Limit_Max                                                     3

// SAEEssSolarRadiation_Limit
#define SAEEssSolarRadiation_Limit_Min                                                  0
#define SAEEssSolarRadiation_Limit_Max                                                  65535

// SAEExitService_SeqSize
#define SAEExitService_SeqSize_Min                                                      1
#define SAEExitService_SeqSize_Max                                                      16

// SAEExtent_Limit
#define SAEExtent_Limit_Min                                                             0
#define SAEExtent_Limit_Max                                                             15

// SAEExteriorLights
#define SAEExteriorLights_lowBeamHeadlightsOn                                           0
#define SAEExteriorLights_highBeamHeadlightsOn                                          1
#define SAEExteriorLights_leftTurnSignalOn                                              2
#define SAEExteriorLights_rightTurnSignalOn                                             3
#define SAEExteriorLights_hazardSignalOn                                                4
#define SAEExteriorLights_automaticLightControlOn                                       5
#define SAEExteriorLights_daytimeRunningLightsOn                                        6
#define SAEExteriorLights_fogLightOn                                                    7
#define SAEExteriorLights_parkingLightsOn                                               8
#define SAEExteriorLights_NumBits                                                       9

// SAEFuelType
#define SAEFuelType_unknownFuel                                                         0
#define SAEFuelType_gasoline                                                            1
#define SAEFuelType_ethanol                                                             2
#define SAEFuelType_diesel                                                              3
#define SAEFuelType_electric                                                            4
#define SAEFuelType_hybrid                                                              5
#define SAEFuelType_hydrogen                                                            6
#define SAEFuelType_natGasLiquid                                                        7
#define SAEFuelType_natGasComp                                                          8
#define SAEFuelType_propane                                                             9

// SAEFuelType_Limit
#define SAEFuelType_Limit_Min                                                           0
#define SAEFuelType_Limit_Max                                                           15

// SAEFurtherInfoID
#define SAEFurtherInfoID_NumOctets                                                      2

// SAEGNSSstatus
#define SAEGNSSstatus_unavailable                                                       0
#define SAEGNSSstatus_isHealthy                                                         1
#define SAEGNSSstatus_isMonitored                                                       2
#define SAEGNSSstatus_baseStationType                                                   3
#define SAEGNSSstatus_aPDOPofUnder5                                                     4
#define SAEGNSSstatus_inViewOfUnder5                                                    5
#define SAEGNSSstatus_localCorrectionsPresent                                           6
#define SAEGNSSstatus_networkCorrectionsPresent                                         7
#define SAEGNSSstatus_NumBits                                                           8

// SAEGenericLocations_Limit
#define SAEGenericLocations_Limit_Min                                                   7937
#define SAEGenericLocations_Limit_Max                                                   8033

// SAEGenericSignage_SeqSize
#define SAEGenericSignage_SeqSize_Min                                                   1
#define SAEGenericSignage_SeqSize_Max                                                   16

// SAEGrossDistance_Limit
#define SAEGrossDistance_Limit_Min                                                      0
#define SAEGrossDistance_Limit_Max                                                      1023

// SAEGrossSpeed_Limit
#define SAEGrossSpeed_Limit_Min                                                         0
#define SAEGrossSpeed_Limit_Max                                                         31

// SAEHeadingConfidence_Limit
#define SAEHeadingConfidence_Limit_Min                                                  0
#define SAEHeadingConfidence_Limit_Max                                                  7

// SAEHeadingSlice
#define SAEHeadingSlice_from000_0to022_5degrees                                         0
#define SAEHeadingSlice_from022_5to045_0degrees                                         1
#define SAEHeadingSlice_from045_0to067_5degrees                                         2
#define SAEHeadingSlice_from067_5to090_0degrees                                         3
#define SAEHeadingSlice_from090_0to112_5degrees                                         4
#define SAEHeadingSlice_from112_5to135_0degrees                                         5
#define SAEHeadingSlice_from135_0to157_5degrees                                         6
#define SAEHeadingSlice_from157_5to180_0degrees                                         7
#define SAEHeadingSlice_from180_0to202_5degrees                                         8
#define SAEHeadingSlice_from202_5to225_0degrees                                         9
#define SAEHeadingSlice_from225_0to247_5degrees                                         10
#define SAEHeadingSlice_from247_5to270_0degrees                                         11
#define SAEHeadingSlice_from270_0to292_5degrees                                         12
#define SAEHeadingSlice_from292_5to315_0degrees                                         13
#define SAEHeadingSlice_from315_0to337_5degrees                                         14
#define SAEHeadingSlice_from337_5to360_0degrees                                         15
#define SAEHeadingSlice_NumBits                                                         16

// SAEHeading_Limit
#define SAEHeading_Limit_Min                                                            0
#define SAEHeading_Limit_Max                                                            28800

// SAEHoliday_Limit
#define SAEHoliday_Limit_Min                                                            0
#define SAEHoliday_Limit_Max                                                            1

// SAEHour_Limit
#define SAEHour_Limit_Min                                                               0
#define SAEHour_Limit_Max                                                               255

// SAEHumanPropelledType_Limit
#define SAEHumanPropelledType_Limit_Min                                                 0
#define SAEHumanPropelledType_Limit_Max                                                 5

// SAEITIScodesAndText_SeqSize
#define SAEITIScodesAndText_SeqSize_Min                                                 1
#define SAEITIScodesAndText_SeqSize_Max                                                 100

// SAEITIScodes_Limit
#define SAEITIScodes_Limit_Min                                                          0
#define SAEITIScodes_Limit_Max                                                          65535

// SAEITIStext
#define SAEITIStext_NumOctets                                                           500

// SAEITIStextPhrase
#define SAEITIStextPhrase_NumOctets                                                     16

// SAEIncidentResponseEquipment_Limit
#define SAEIncidentResponseEquipment_Limit_Min                                          9985
#define SAEIncidentResponseEquipment_Limit_Max                                          10114

// SAEIntersectionGeometryList_SeqSize
#define SAEIntersectionGeometryList_SeqSize_Min                                         1
#define SAEIntersectionGeometryList_SeqSize_Max                                         32

// SAEIntersectionID_Limit
#define SAEIntersectionID_Limit_Min                                                     0
#define SAEIntersectionID_Limit_Max                                                     65535

// SAEIntersectionStateList_SeqSize
#define SAEIntersectionStateList_SeqSize_Min                                            1
#define SAEIntersectionStateList_SeqSize_Max                                            32

// SAEIntersectionStatusObject
#define SAEIntersectionStatusObject_manualControlIsEnabled                              0
#define SAEIntersectionStatusObject_stopTimeIsActivated                                 1
#define SAEIntersectionStatusObject_failureFlash                                        2
#define SAEIntersectionStatusObject_preemptIsActive                                     3
#define SAEIntersectionStatusObject_signalPriorityIsActive                              4
#define SAEIntersectionStatusObject_fixedTimeOperation                                  5
#define SAEIntersectionStatusObject_trafficDependentOperation                           6
#define SAEIntersectionStatusObject_standbyOperation                                    7
#define SAEIntersectionStatusObject_failureMode                                         8
#define SAEIntersectionStatusObject_off                                                 9
#define SAEIntersectionStatusObject_recentMAPmessageUpdate                              10
#define SAEIntersectionStatusObject_recentChangeInMAPassignedLanesIDsUsed               11
#define SAEIntersectionStatusObject_noValidMAPisAvailableAtThisTime                     12
#define SAEIntersectionStatusObject_noValidSPATisAvailableAtThisTime                    13
#define SAEIntersectionStatusObject_NumBits                                             16

// SAEIso3833VehicleType_Limit
#define SAEIso3833VehicleType_Limit_Min                                                 0
#define SAEIso3833VehicleType_Limit_Max                                                 100

// SAELaneAttributes_Barrier
#define SAELaneAttributes_Barrier_median_RevocableLane                                  0
#define SAELaneAttributes_Barrier_median                                                1
#define SAELaneAttributes_Barrier_whiteLineHashing                                      2
#define SAELaneAttributes_Barrier_stripedLines                                          3
#define SAELaneAttributes_Barrier_doubleStripedLines                                    4
#define SAELaneAttributes_Barrier_trafficCones                                          5
#define SAELaneAttributes_Barrier_constructionBarrier                                   6
#define SAELaneAttributes_Barrier_trafficChannels                                       7
#define SAELaneAttributes_Barrier_lowCurbs                                              8
#define SAELaneAttributes_Barrier_highCurbs                                             9
#define SAELaneAttributes_Barrier_NumBits                                               16

// SAELaneAttributes_Bike
#define SAELaneAttributes_Bike_bikeRevocableLane                                        0
#define SAELaneAttributes_Bike_pedestrianUseAllowed                                     1
#define SAELaneAttributes_Bike_isBikeFlyOverLane                                        2
#define SAELaneAttributes_Bike_fixedCycleTime                                           3
#define SAELaneAttributes_Bike_biDirectionalCycleTimes                                  4
#define SAELaneAttributes_Bike_isolatedByBarrier                                        5
#define SAELaneAttributes_Bike_unsignalizedSegmentsPresent                              6
#define SAELaneAttributes_Bike_NumBits                                                  16

// SAELaneAttributes_Crosswalk
#define SAELaneAttributes_Crosswalk_crosswalkRevocableLane                              0
#define SAELaneAttributes_Crosswalk_bicyleUseAllowed                                    1
#define SAELaneAttributes_Crosswalk_isXwalkFlyOverLane                                  2
#define SAELaneAttributes_Crosswalk_fixedCycleTime                                      3
#define SAELaneAttributes_Crosswalk_biDirectionalCycleTimes                             4
#define SAELaneAttributes_Crosswalk_hasPushToWalkButton                                 5
#define SAELaneAttributes_Crosswalk_audioSupport                                        6
#define SAELaneAttributes_Crosswalk_rfSignalRequestPresent                              7
#define SAELaneAttributes_Crosswalk_unsignalizedSegmentsPresent                         8
#define SAELaneAttributes_Crosswalk_NumBits                                             16

// SAELaneAttributes_Parking
#define SAELaneAttributes_Parking_parkingRevocableLane                                  0
#define SAELaneAttributes_Parking_parallelParkingInUse                                  1
#define SAELaneAttributes_Parking_headInParkingInUse                                    2
#define SAELaneAttributes_Parking_doNotParkZone                                         3
#define SAELaneAttributes_Parking_parkingForBusUse                                      4
#define SAELaneAttributes_Parking_parkingForTaxiUse                                     5
#define SAELaneAttributes_Parking_noPublicParkingUse                                    6
#define SAELaneAttributes_Parking_NumBits                                               16

// SAELaneAttributes_Sidewalk
#define SAELaneAttributes_Sidewalk_sidewalk_RevocableLane                               0
#define SAELaneAttributes_Sidewalk_bicyleUseAllowed                                     1
#define SAELaneAttributes_Sidewalk_isSidewalkFlyOverLane                                2
#define SAELaneAttributes_Sidewalk_walkBikes                                            3
#define SAELaneAttributes_Sidewalk_NumBits                                              16

// SAELaneAttributes_Striping
#define SAELaneAttributes_Striping_stripeToConnectingLanesRevocableLane                 0
#define SAELaneAttributes_Striping_stripeDrawOnLeft                                     1
#define SAELaneAttributes_Striping_stripeDrawOnRight                                    2
#define SAELaneAttributes_Striping_stripeToConnectingLanesLeft                          3
#define SAELaneAttributes_Striping_stripeToConnectingLanesRight                         4
#define SAELaneAttributes_Striping_stripeToConnectingLanesAhead                         5
#define SAELaneAttributes_Striping_NumBits                                              16

// SAELaneAttributes_TrackedVehicle
#define SAELaneAttributes_TrackedVehicle_spec_RevocableLane                             0
#define SAELaneAttributes_TrackedVehicle_spec_commuterRailRoadTrack                     1
#define SAELaneAttributes_TrackedVehicle_spec_lightRailRoadTrack                        2
#define SAELaneAttributes_TrackedVehicle_spec_heavyRailRoadTrack                        3
#define SAELaneAttributes_TrackedVehicle_spec_otherRailType                             4
#define SAELaneAttributes_TrackedVehicle_NumBits                                        16

// SAELaneAttributes_Vehicle
#define SAELaneAttributes_Vehicle_isVehicleRevocableLane                                0
#define SAELaneAttributes_Vehicle_isVehicleFlyOverLane                                  1
#define SAELaneAttributes_Vehicle_hovLaneUseOnly                                        2
#define SAELaneAttributes_Vehicle_restrictedToBusUse                                    3
#define SAELaneAttributes_Vehicle_restrictedToTaxiUse                                   4
#define SAELaneAttributes_Vehicle_restrictedFromPublicUse                               5
#define SAELaneAttributes_Vehicle_hasIRbeaconCoverage                                   6
#define SAELaneAttributes_Vehicle_permissionOnRequest                                   7
#define SAELaneAttributes_Vehicle_NumBits                                               8

// SAELaneConnectionID_Limit
#define SAELaneConnectionID_Limit_Min                                                   0
#define SAELaneConnectionID_Limit_Max                                                   255

// SAELaneDataAttributeList_SeqSize
#define SAELaneDataAttributeList_SeqSize_Min                                            1
#define SAELaneDataAttributeList_SeqSize_Max                                            8

// SAELaneDirection
#define SAELaneDirection_ingressPath                                                    0
#define SAELaneDirection_egressPath                                                     1
#define SAELaneDirection_NumBits                                                        2

// SAELaneID_Limit
#define SAELaneID_Limit_Min                                                             0
#define SAELaneID_Limit_Max                                                             255

// SAELaneList_SeqSize
#define SAELaneList_SeqSize_Min                                                         1
#define SAELaneList_SeqSize_Max                                                         255

// SAELaneSharing
#define SAELaneSharing_overlappingLaneDescriptionProvided                               0
#define SAELaneSharing_multipleLanesTreatedAsOneLane                                    1
#define SAELaneSharing_otherNonMotorizedTrafficTypes                                    2
#define SAELaneSharing_individualMotorizedVehicleTraffic                                3
#define SAELaneSharing_busVehicleTraffic                                                4
#define SAELaneSharing_taxiVehicleTraffic                                               5
#define SAELaneSharing_pedestriansTraffic                                               6
#define SAELaneSharing_cyclistVehicleTraffic                                            7
#define SAELaneSharing_trackedVehicleTraffic                                            8
#define SAELaneSharing_pedestrianTraffic                                                9
#define SAELaneSharing_NumBits                                                          10

// SAELaneWidth_Limit
#define SAELaneWidth_Limit_Min                                                          0
#define SAELaneWidth_Limit_Max                                                          32767

// SAELatitudeDMS_Limit
#define SAELatitudeDMS_Limit_Min                                                        -32400000
#define SAELatitudeDMS_Limit_Max                                                        32400000

// SAELatitude_Limit
#define SAELatitude_Limit_Min                                                           -900000000
#define SAELatitude_Limit_Max                                                           900000001

// SAELayerID_Limit
#define SAELayerID_Limit_Min                                                            0
#define SAELayerID_Limit_Max                                                            100

// SAELightbarInUse_Limit
#define SAELightbarInUse_Limit_Min                                                      0
#define SAELightbarInUse_Limit_Max                                                      7

// SAELocation_quality_Limit
#define SAELocation_quality_Limit_Min                                                   0
#define SAELocation_quality_Limit_Max                                                   7

// SAELocation_tech_Limit
#define SAELocation_tech_Limit_Min                                                      0
#define SAELocation_tech_Limit_Max                                                      9

// SAELongitudeDMS_Limit
#define SAELongitudeDMS_Limit_Min                                                       -64800000
#define SAELongitudeDMS_Limit_Max                                                       64800000

// SAELongitude_Limit
#define SAELongitude_Limit_Min                                                          -1799999999
#define SAELongitude_Limit_Max                                                          1800000001

// SAEMUTCDCode_Limit
#define SAEMUTCDCode_Limit_Min                                                          0
#define SAEMUTCDCode_Limit_Max                                                          6

// SAEManeuverAssistList_SeqSize
#define SAEManeuverAssistList_SeqSize_Min                                               1
#define SAEManeuverAssistList_SeqSize_Max                                               16

// SAEMaxTimetoChange_Limit
#define SAEMaxTimetoChange_Limit_Min                                                    0
#define SAEMaxTimetoChange_Limit_Max                                                    2402

// SAEMergeDivergeNodeAngle_Limit
#define SAEMergeDivergeNodeAngle_Limit_Min                                              -180
#define SAEMergeDivergeNodeAngle_Limit_Max                                              180

// SAEMessageBLOB
#define SAEMessageBLOB_NumOctets                                                        2000

// SAEMinTimetoChange_Limit
#define SAEMinTimetoChange_Limit_Min                                                    0
#define SAEMinTimetoChange_Limit_Max                                                    2402

// SAEMinuteOfTheYear_Limit
#define SAEMinuteOfTheYear_Limit_Min                                                    0
#define SAEMinuteOfTheYear_Limit_Max                                                    527040

// SAEMinute_Limit
#define SAEMinute_Limit_Min                                                             0
#define SAEMinute_Limit_Max                                                             255

// SAEMinutesAngle_Limit
#define SAEMinutesAngle_Limit_Min                                                       0
#define SAEMinutesAngle_Limit_Max                                                       59

// SAEMinutesDuration_Limit
#define SAEMinutesDuration_Limit_Min                                                    0
#define SAEMinutesDuration_Limit_Max                                                    32000

// SAEMonth_Limit
#define SAEMonth_Limit_Min                                                              1
#define SAEMonth_Limit_Max                                                              255

// SAEMotorizedPropelledType_Limit
#define SAEMotorizedPropelledType_Limit_Min                                             0
#define SAEMotorizedPropelledType_Limit_Max                                             5

// SAEMovementEventList_SeqSize
#define SAEMovementEventList_SeqSize_Min                                                1
#define SAEMovementEventList_SeqSize_Max                                                16

// SAEMovementList_SeqSize
#define SAEMovementList_SeqSize_Min                                                     1
#define SAEMovementList_SeqSize_Max                                                     255

// SAEMovementPhaseState_Limit
#define SAEMovementPhaseState_Limit_Min                                                 0
#define SAEMovementPhaseState_Limit_Max                                                 9

// SAEMsgCRC
#define SAEMsgCRC_NumOctets                                                             2

// SAEMsgCount_Limit
#define SAEMsgCount_Limit_Min                                                           0
#define SAEMsgCount_Limit_Max                                                           127

// SAEMultiVehicleResponse_Limit
#define SAEMultiVehicleResponse_Limit_Min                                               0
#define SAEMultiVehicleResponse_Limit_Max                                               3

// SAENMEA_MsgType_Limit
#define SAENMEA_MsgType_Limit_Min                                                       0
#define SAENMEA_MsgType_Limit_Max                                                       32767

// SAENMEA_Payload
#define SAENMEA_Payload_NumOctets                                                       1023

// SAENMEA_Revision_Limit
#define SAENMEA_Revision_Limit_Min                                                      0
#define SAENMEA_Revision_Limit_Max                                                      6

// SAENodeAttributeLLList_SeqSize
#define SAENodeAttributeLLList_SeqSize_Min                                              1
#define SAENodeAttributeLLList_SeqSize_Max                                              8

// SAENodeAttributeXYList_SeqSize
#define SAENodeAttributeXYList_SeqSize_Min                                              1
#define SAENodeAttributeXYList_SeqSize_Max                                              8

// SAENodeSetLL_SeqSize
#define SAENodeSetLL_SeqSize_Min                                                        2
#define SAENodeSetLL_SeqSize_Max                                                        63

// SAENodeSetXY_SeqSize
#define SAENodeSetXY_SeqSize_Min                                                        2
#define SAENodeSetXY_SeqSize_Max                                                        63

// SAENumberOfParticipantsInCluster_Limit
#define SAENumberOfParticipantsInCluster_Limit_Min                                      0
#define SAENumberOfParticipantsInCluster_Limit_Max                                      3

// SAEObjectCount_Limit
#define SAEObjectCount_Limit_Min                                                        0
#define SAEObjectCount_Limit_Max                                                        1023

// SAEObstacleDistance_Limit
#define SAEObstacleDistance_Limit_Min                                                   0
#define SAEObstacleDistance_Limit_Max                                                   32767

// SAEOffsetLL_B12_Limit
#define SAEOffsetLL_B12_Limit_Min                                                       -2048
#define SAEOffsetLL_B12_Limit_Max                                                       2047

// SAEOffsetLL_B14_Limit
#define SAEOffsetLL_B14_Limit_Min                                                       -8192
#define SAEOffsetLL_B14_Limit_Max                                                       8191

// SAEOffsetLL_B16_Limit
#define SAEOffsetLL_B16_Limit_Min                                                       -32768
#define SAEOffsetLL_B16_Limit_Max                                                       32767

// SAEOffsetLL_B18_Limit
#define SAEOffsetLL_B18_Limit_Min                                                       -131072
#define SAEOffsetLL_B18_Limit_Max                                                       131071

// SAEOffsetLL_B22_Limit
#define SAEOffsetLL_B22_Limit_Min                                                       -2097152
#define SAEOffsetLL_B22_Limit_Max                                                       2097151

// SAEOffsetLL_B24_Limit
#define SAEOffsetLL_B24_Limit_Min                                                       -8388608
#define SAEOffsetLL_B24_Limit_Max                                                       8388607

// SAEOffset_B09_Limit
#define SAEOffset_B09_Limit_Min                                                         -256
#define SAEOffset_B09_Limit_Max                                                         255

// SAEOffset_B10_Limit
#define SAEOffset_B10_Limit_Min                                                         -512
#define SAEOffset_B10_Limit_Max                                                         511

// SAEOffset_B11_Limit
#define SAEOffset_B11_Limit_Min                                                         -1024
#define SAEOffset_B11_Limit_Max                                                         1023

// SAEOffset_B12_Limit
#define SAEOffset_B12_Limit_Min                                                         -2048
#define SAEOffset_B12_Limit_Max                                                         2047

// SAEOffset_B13_Limit
#define SAEOffset_B13_Limit_Min                                                         -4096
#define SAEOffset_B13_Limit_Max                                                         4095

// SAEOffset_B14_Limit
#define SAEOffset_B14_Limit_Min                                                         -8192
#define SAEOffset_B14_Limit_Max                                                         8191

// SAEOffset_B16_Limit
#define SAEOffset_B16_Limit_Min                                                         -32768
#define SAEOffset_B16_Limit_Max                                                         32767

// SAEOverlayLaneList_SeqSize
#define SAEOverlayLaneList_SeqSize_Min                                                  1
#define SAEOverlayLaneList_SeqSize_Max                                                  5

// SAEPartII_Id
#define SAEPartII_Id_vehicleSafetyExt                                                   0
#define SAEPartII_Id_specialVehicleExt                                                  1
#define SAEPartII_Id_supplementalVehicleExt                                             2

// SAEPartII_Id_Limit
#define SAEPartII_Id_Limit_Min                                                          0
#define SAEPartII_Id_Limit_Max                                                          63

// SAEPathHistoryPointList_SeqSize
#define SAEPathHistoryPointList_SeqSize_Min                                             1
#define SAEPathHistoryPointList_SeqSize_Max                                             23

// SAEPayloadData
#define SAEPayloadData_NumOctets                                                        2048

// SAEPersonalAssistive
#define SAEPersonalAssistive_unavailable                                                0
#define SAEPersonalAssistive_otherType                                                  1
#define SAEPersonalAssistive_vision                                                     2
#define SAEPersonalAssistive_hearing                                                    3
#define SAEPersonalAssistive_movement                                                   4
#define SAEPersonalAssistive_cognition                                                  5
#define SAEPersonalAssistive_NumBits                                                    6

// SAEPersonalClusterRadius_Limit
#define SAEPersonalClusterRadius_Limit_Min                                              0
#define SAEPersonalClusterRadius_Limit_Max                                              100

// SAEPersonalDeviceUsageState
#define SAEPersonalDeviceUsageState_unavailable                                         0
#define SAEPersonalDeviceUsageState_other                                               1
#define SAEPersonalDeviceUsageState_idle                                                2
#define SAEPersonalDeviceUsageState_listeningToAudio                                    3
#define SAEPersonalDeviceUsageState_typing                                              4
#define SAEPersonalDeviceUsageState_calling                                             5
#define SAEPersonalDeviceUsageState_playingGames                                        6
#define SAEPersonalDeviceUsageState_reading                                             7
#define SAEPersonalDeviceUsageState_viewing                                             8
#define SAEPersonalDeviceUsageState_NumBits                                             9

// SAEPersonalDeviceUserType_Limit
#define SAEPersonalDeviceUserType_Limit_Min                                             0
#define SAEPersonalDeviceUserType_Limit_Max                                             4

// SAEPositionConfidence_Limit
#define SAEPositionConfidence_Limit_Min                                                 0
#define SAEPositionConfidence_Limit_Max                                                 15

// SAEPreemptPriorityList_SeqSize
#define SAEPreemptPriorityList_SeqSize_Min                                              1
#define SAEPreemptPriorityList_SeqSize_Max                                              32

// SAEPrioritizationResponseList_SeqSize
#define SAEPrioritizationResponseList_SeqSize_Min                                       1
#define SAEPrioritizationResponseList_SeqSize_Max                                       10

// SAEPrioritizationResponseStatus_Limit
#define SAEPrioritizationResponseStatus_Limit_Min                                       0
#define SAEPrioritizationResponseStatus_Limit_Max                                       7

// SAEPriority
#define SAEPriority_NumOctets                                                           1

// SAEPriorityRequestType_Limit
#define SAEPriorityRequestType_Limit_Min                                                0
#define SAEPriorityRequestType_Limit_Max                                                3

// SAEPrivilegedEventFlags
#define SAEPrivilegedEventFlags_peUnavailable                                           0
#define SAEPrivilegedEventFlags_peEmergencyResponse                                     1
#define SAEPrivilegedEventFlags_peEmergencyLightsActive                                 2
#define SAEPrivilegedEventFlags_peEmergencySoundActive                                  3
#define SAEPrivilegedEventFlags_peNonEmergencyLightsActive                              4
#define SAEPrivilegedEventFlags_peNonEmergencySoundActive                               5
#define SAEPrivilegedEventFlags_NumBits                                                 16

// SAEProbeSegmentNumber_Limit
#define SAEProbeSegmentNumber_Limit_Min                                                 0
#define SAEProbeSegmentNumber_Limit_Max                                                 32767

// SAEPublicSafetyAndRoadWorkerActivity
#define SAEPublicSafetyAndRoadWorkerActivity_unavailable                                0
#define SAEPublicSafetyAndRoadWorkerActivity_workingOnRoad                              1
#define SAEPublicSafetyAndRoadWorkerActivity_settingUpClosures                          2
#define SAEPublicSafetyAndRoadWorkerActivity_respondingToEvents                         3
#define SAEPublicSafetyAndRoadWorkerActivity_directingTraffic                           4
#define SAEPublicSafetyAndRoadWorkerActivity_otherActivities                            5
#define SAEPublicSafetyAndRoadWorkerActivity_NumBits                                    6

// SAEPublicSafetyDirectingTrafficSubType
#define SAEPublicSafetyDirectingTrafficSubType_unavailable                              0
#define SAEPublicSafetyDirectingTrafficSubType_policeAndTrafficOfficers                 1
#define SAEPublicSafetyDirectingTrafficSubType_trafficControlPersons                    2
#define SAEPublicSafetyDirectingTrafficSubType_railroadCrossingGuards                   3
#define SAEPublicSafetyDirectingTrafficSubType_civilDefenseNationalGuardMilitaryPolice  4
#define SAEPublicSafetyDirectingTrafficSubType_emergencyOrganizationPersonnel           5
#define SAEPublicSafetyDirectingTrafficSubType_highwayServiceVehiclePersonnel           6
#define SAEPublicSafetyDirectingTrafficSubType_NumBits                                  7

// SAEPublicSafetyEventResponderWorkerType_Limit
#define SAEPublicSafetyEventResponderWorkerType_Limit_Min                               0
#define SAEPublicSafetyEventResponderWorkerType_Limit_Max                               7

// SAERTCM_Revision_Limit
#define SAERTCM_Revision_Limit_Min                                                      0
#define SAERTCM_Revision_Limit_Max                                                      3

// SAERTCMmessage
#define SAERTCMmessage_NumOctets                                                        1023

// SAERTCMmessageList_SeqSize
#define SAERTCMmessageList_SeqSize_Min                                                  1
#define SAERTCMmessageList_SeqSize_Max                                                  5

// SAERadiusOfCurvature_Limit
#define SAERadiusOfCurvature_Limit_Min                                                  -32767
#define SAERadiusOfCurvature_Limit_Max                                                  32767

// SAERadius_B12_Limit
#define SAERadius_B12_Limit_Min                                                         0
#define SAERadius_B12_Limit_Max                                                         4095

// SAERainSensor_Limit
#define SAERainSensor_Limit_Min                                                         0
#define SAERainSensor_Limit_Max                                                         7

// SAERegionId
#define SAERegionId_noRegion                                                            0
#define SAERegionId_addGrpA                                                             1
#define SAERegionId_addGrpB                                                             2
#define SAERegionId_addGrpC                                                             3

// SAERegionId_Limit
#define SAERegionId_Limit_Min                                                           0
#define SAERegionId_Limit_Max                                                           255

// SAERegionList_SeqSize
#define SAERegionList_SeqSize_Min                                                       1
#define SAERegionList_SeqSize_Max                                                       64

// SAERequestID_Limit
#define SAERequestID_Limit_Min                                                          0
#define SAERequestID_Limit_Max                                                          255

// SAERequestImportanceLevel_Limit
#define SAERequestImportanceLevel_Limit_Min                                             0
#define SAERequestImportanceLevel_Limit_Max                                             15

// SAERequestSubRole_Limit
#define SAERequestSubRole_Limit_Min                                                     0
#define SAERequestSubRole_Limit_Max                                                     15

// SAERequestedItemList_SeqSize
#define SAERequestedItemList_SeqSize_Min                                                1
#define SAERequestedItemList_SeqSize_Max                                                32

// SAEResponderGroupAffected_Limit
#define SAEResponderGroupAffected_Limit_Min                                             9729
#define SAEResponderGroupAffected_Limit_Max                                             9742

// SAEResponseType_Limit
#define SAEResponseType_Limit_Min                                                       0
#define SAEResponseType_Limit_Max                                                       6

// SAERestrictionClassID_Limit
#define SAERestrictionClassID_Limit_Min                                                 0
#define SAERestrictionClassID_Limit_Max                                                 255

// SAERestrictionClassList_SeqSize
#define SAERestrictionClassList_SeqSize_Min                                             1
#define SAERestrictionClassList_SeqSize_Max                                             254

// SAERestrictionUserTypeList_SeqSize
#define SAERestrictionUserTypeList_SeqSize_Min                                          1
#define SAERestrictionUserTypeList_SeqSize_Max                                          16

// SAERoadLaneSetList_SeqSize
#define SAERoadLaneSetList_SeqSize_Min                                                  1
#define SAERoadLaneSetList_SeqSize_Max                                                  255

// SAERoadRegulatorID_Limit
#define SAERoadRegulatorID_Limit_Min                                                    0
#define SAERoadRegulatorID_Limit_Max                                                    65535

// SAERoadSegmentID_Limit
#define SAERoadSegmentID_Limit_Min                                                      0
#define SAERoadSegmentID_Limit_Max                                                      65535

// SAERoadSegmentList_SeqSize
#define SAERoadSegmentList_SeqSize_Min                                                  1
#define SAERoadSegmentList_SeqSize_Max                                                  32

// SAERoadwayCrownAngle_Limit
#define SAERoadwayCrownAngle_Limit_Min                                                  -128
#define SAERoadwayCrownAngle_Limit_Max                                                  127

// SAESSPindex_Limit
#define SAESSPindex_Limit_Min                                                           0
#define SAESSPindex_Limit_Max                                                           31

// SAESampleSampleEnd_Limit
#define SAESampleSampleEnd_Limit_Min                                                    0
#define SAESampleSampleEnd_Limit_Max                                                    255

// SAESampleSampleStart_Limit
#define SAESampleSampleStart_Limit_Min                                                  0
#define SAESampleSampleStart_Limit_Max                                                  255

// SAEScale_B12_Limit
#define SAEScale_B12_Limit_Min                                                          -2048
#define SAEScale_B12_Limit_Max                                                          2047

// SAESecondOfTime_Limit
#define SAESecondOfTime_Limit_Min                                                       0
#define SAESecondOfTime_Limit_Max                                                       61

// SAESecond_Limit
#define SAESecond_Limit_Min                                                             0
#define SAESecond_Limit_Max                                                             60

// SAESecondsAngle_Limit
#define SAESecondsAngle_Limit_Min                                                       0
#define SAESecondsAngle_Limit_Max                                                       5999

// SAESegmentAttributeLLList_SeqSize
#define SAESegmentAttributeLLList_SeqSize_Min                                           1
#define SAESegmentAttributeLLList_SeqSize_Max                                           8

// SAESegmentAttributeXYList_SeqSize
#define SAESegmentAttributeXYList_SeqSize_Min                                           1
#define SAESegmentAttributeXYList_SeqSize_Max                                           8

// SAESemiMajorAxisAccuracy_Limit
#define SAESemiMajorAxisAccuracy_Limit_Min                                              0
#define SAESemiMajorAxisAccuracy_Limit_Max                                              255

// SAESemiMajorAxisOrientation_Limit
#define SAESemiMajorAxisOrientation_Limit_Min                                           0
#define SAESemiMajorAxisOrientation_Limit_Max                                           65535

// SAESemiMinorAxisAccuracy_Limit
#define SAESemiMinorAxisAccuracy_Limit_Min                                              0
#define SAESemiMinorAxisAccuracy_Limit_Max                                              255

// SAESignPrority_Limit
#define SAESignPrority_Limit_Min                                                        0
#define SAESignPrority_Limit_Max                                                        7

// SAESignalGroupID_Limit
#define SAESignalGroupID_Limit_Min                                                      0
#define SAESignalGroupID_Limit_Max                                                      255

// SAESignalHeadLocationList_SeqSize
#define SAESignalHeadLocationList_SeqSize_Min                                           1
#define SAESignalHeadLocationList_SeqSize_Max                                           20

// SAESignalReqScheme
#define SAESignalReqScheme_NumOctets                                                    1

// SAESignalRequestList_SeqSize
#define SAESignalRequestList_SeqSize_Min                                                1
#define SAESignalRequestList_SeqSize_Max                                                32

// SAESignalStatusList_SeqSize
#define SAESignalStatusList_SeqSize_Min                                                 1
#define SAESignalStatusList_SeqSize_Max                                                 32

// SAESignalStatusPackageList_SeqSize
#define SAESignalStatusPackageList_SeqSize_Min                                          1
#define SAESignalStatusPackageList_SeqSize_Max                                          32

// SAESirenInUse_Limit
#define SAESirenInUse_Limit_Min                                                         0
#define SAESirenInUse_Limit_Max                                                         3

// SAESpeedAdvice_Limit
#define SAESpeedAdvice_Limit_Min                                                        0
#define SAESpeedAdvice_Limit_Max                                                        500

// SAESpeedConfidence_Limit
#define SAESpeedConfidence_Limit_Min                                                    0
#define SAESpeedConfidence_Limit_Max                                                    7

// SAESpeedLimitList_SeqSize
#define SAESpeedLimitList_SeqSize_Min                                                   1
#define SAESpeedLimitList_SeqSize_Max                                                   9

// SAESpeedLimit_SeqSize
#define SAESpeedLimit_SeqSize_Min                                                       1
#define SAESpeedLimit_SeqSize_Max                                                       16

// SAESpeedProfileMeasurementList_SeqSize
#define SAESpeedProfileMeasurementList_SeqSize_Min                                      1
#define SAESpeedProfileMeasurementList_SeqSize_Max                                      20

// SAESpeed_Limit
#define SAESpeed_Limit_Min                                                              0
#define SAESpeed_Limit_Max                                                              8191

// SAEStabilityControlStatus_Limit
#define SAEStabilityControlStatus_Limit_Min                                             0
#define SAEStabilityControlStatus_Limit_Max                                             3

// SAEStationID_Limit
#define SAEStationID_Limit_Min                                                          0
#define SAEStationID_Limit_Max                                                          4294967295

// SAESteeringAxleLubePressure_Limit
#define SAESteeringAxleLubePressure_Limit_Min                                           0
#define SAESteeringAxleLubePressure_Limit_Max                                           250

// SAESteeringAxleTemperature_Limit
#define SAESteeringAxleTemperature_Limit_Min                                            -40
#define SAESteeringAxleTemperature_Limit_Max                                            210

// SAESteeringWheelAngleConfidence_Limit
#define SAESteeringWheelAngleConfidence_Limit_Min                                       0
#define SAESteeringWheelAngleConfidence_Limit_Max                                       3

// SAESteeringWheelAngleRateOfChange_Limit
#define SAESteeringWheelAngleRateOfChange_Limit_Min                                     -127
#define SAESteeringWheelAngleRateOfChange_Limit_Max                                     127

// SAESteeringWheelAngle_Limit
#define SAESteeringWheelAngle_Limit_Min                                                 -126
#define SAESteeringWheelAngle_Limit_Max                                                 127

// SAESummerTime_Limit
#define SAESummerTime_Limit_Min                                                         0
#define SAESummerTime_Limit_Max                                                         1

// SAESunSensor_Limit
#define SAESunSensor_Limit_Min                                                          0
#define SAESunSensor_Limit_Max                                                          1000

// SAETemporaryID
#define SAETemporaryID_NumOctets                                                        4

// SAETenthSecond_Limit
#define SAETenthSecond_Limit_Min                                                        0
#define SAETenthSecond_Limit_Max                                                        9

// SAETermDistance_Limit
#define SAETermDistance_Limit_Min                                                       1
#define SAETermDistance_Limit_Max                                                       30000

// SAETermTime_Limit
#define SAETermTime_Limit_Min                                                           1
#define SAETermTime_Limit_Max                                                           1800

// SAEThrottleConfidence_Limit
#define SAEThrottleConfidence_Limit_Min                                                 0
#define SAEThrottleConfidence_Limit_Max                                                 3

// SAEThrottlePosition_Limit
#define SAEThrottlePosition_Limit_Min                                                   0
#define SAEThrottlePosition_Limit_Max                                                   200

// SAETimeConfidence_Limit
#define SAETimeConfidence_Limit_Min                                                     0
#define SAETimeConfidence_Limit_Max                                                     39

// SAETimeIntervalConfidence_Limit
#define SAETimeIntervalConfidence_Limit_Min                                             0
#define SAETimeIntervalConfidence_Limit_Max                                             15

// SAETimeMark_Limit
#define SAETimeMark_Limit_Min                                                           0
#define SAETimeMark_Limit_Max                                                           36001

// SAETimeOffset_Limit
#define SAETimeOffset_Limit_Min                                                         1
#define SAETimeOffset_Limit_Max                                                         65535

// SAETimeRemaining_Limit
#define SAETimeRemaining_Limit_Min                                                      0
#define SAETimeRemaining_Limit_Max                                                      9001

// SAETireDataList_SeqSize
#define SAETireDataList_SeqSize_Min                                                     1
#define SAETireDataList_SeqSize_Max                                                     16

// SAETireLeakageRate_Limit
#define SAETireLeakageRate_Limit_Min                                                    0
#define SAETireLeakageRate_Limit_Max                                                    64255

// SAETireLocation_Limit
#define SAETireLocation_Limit_Min                                                       0
#define SAETireLocation_Limit_Max                                                       255

// SAETirePressureThresholdDetection_Limit
#define SAETirePressureThresholdDetection_Limit_Min                                     0
#define SAETirePressureThresholdDetection_Limit_Max                                     7

// SAETirePressure_Limit
#define SAETirePressure_Limit_Min                                                       0
#define SAETirePressure_Limit_Max                                                       250

// SAETireTemp_Limit
#define SAETireTemp_Limit_Min                                                           -8736
#define SAETireTemp_Limit_Max                                                           55519

// SAETractionControlStatus_Limit
#define SAETractionControlStatus_Limit_Min                                              0
#define SAETractionControlStatus_Limit_Max                                              3

// SAETrailerHistoryPointList_SeqSize
#define SAETrailerHistoryPointList_SeqSize_Min                                          1
#define SAETrailerHistoryPointList_SeqSize_Max                                          23

// SAETrailerMass_Limit
#define SAETrailerMass_Limit_Min                                                        0
#define SAETrailerMass_Limit_Max                                                        255

// SAETrailerUnitDescriptionList_SeqSize
#define SAETrailerUnitDescriptionList_SeqSize_Min                                       1
#define SAETrailerUnitDescriptionList_SeqSize_Max                                       8

// SAETrailerWeight_Limit
#define SAETrailerWeight_Limit_Min                                                      0
#define SAETrailerWeight_Limit_Max                                                      64255

// SAETransitStatus
#define SAETransitStatus_none                                                           0
#define SAETransitStatus_anADAuse                                                       1
#define SAETransitStatus_aBikeLoad                                                      2
#define SAETransitStatus_doorOpen                                                       3
#define SAETransitStatus_occM                                                           4
#define SAETransitStatus_occL                                                           5
#define SAETransitStatus_NumBits                                                        6

// SAETransitVehicleOccupancy_Limit
#define SAETransitVehicleOccupancy_Limit_Min                                            0
#define SAETransitVehicleOccupancy_Limit_Max                                            7

// SAETransitVehicleStatus
#define SAETransitVehicleStatus_loading                                                 0
#define SAETransitVehicleStatus_anADAuse                                                1
#define SAETransitVehicleStatus_aBikeLoad                                               2
#define SAETransitVehicleStatus_doorOpen                                                3
#define SAETransitVehicleStatus_charging                                                4
#define SAETransitVehicleStatus_atStopLine                                              5
#define SAETransitVehicleStatus_NumBits                                                 8

// SAETransmissionState_Limit
#define SAETransmissionState_Limit_Min                                                  0
#define SAETransmissionState_Limit_Max                                                  7

// SAETravelerDataFrameList_SeqSize
#define SAETravelerDataFrameList_SeqSize_Min                                            1
#define SAETravelerDataFrameList_SeqSize_Max                                            8

// SAETravelerInfoType_Limit
#define SAETravelerInfoType_Limit_Min                                                   0
#define SAETravelerInfoType_Limit_Max                                                   3

// SAEURL_Base
#define SAEURL_Base_NumOctets                                                           45

// SAEURL_Link
#define SAEURL_Link_NumOctets                                                           255

// SAEURL_Short
#define SAEURL_Short_NumOctets                                                          15

// SAEUniqueMSGID
#define SAEUniqueMSGID_NumOctets                                                        9

// SAEUserSizeAndBehaviour
#define SAEUserSizeAndBehaviour_unavailable                                             0
#define SAEUserSizeAndBehaviour_smallStature                                            1
#define SAEUserSizeAndBehaviour_largeStature                                            2
#define SAEUserSizeAndBehaviour_erraticMoving                                           3
#define SAEUserSizeAndBehaviour_slowMoving                                              4
#define SAEUserSizeAndBehaviour_NumBits                                                 5

// SAEVINstring
#define SAEVINstring_NumOctets                                                          17

// SAEVehicleEventFlags
#define SAEVehicleEventFlags_eventHazardLights                                          0
#define SAEVehicleEventFlags_eventStopLineViolation                                     1
#define SAEVehicleEventFlags_eventABSactivated                                          2
#define SAEVehicleEventFlags_eventTractionControlLoss                                   3
#define SAEVehicleEventFlags_eventStabilityControlactivated                             4
#define SAEVehicleEventFlags_eventHazardousMaterials                                    5
#define SAEVehicleEventFlags_eventReserved1                                             6
#define SAEVehicleEventFlags_eventHardBraking                                           7
#define SAEVehicleEventFlags_eventLightsChanged                                         8
#define SAEVehicleEventFlags_eventWipersChanged                                         9
#define SAEVehicleEventFlags_eventFlatTire                                              10
#define SAEVehicleEventFlags_eventDisabledVehicle                                       11
#define SAEVehicleEventFlags_eventAirBagDeployment                                      12
#define SAEVehicleEventFlags_NumBits                                                    13

// SAEVehicleGroupAffected_Limit
#define SAEVehicleGroupAffected_Limit_Min                                               9217
#define SAEVehicleGroupAffected_Limit_Max                                               9251

// SAEVehicleHeight_Limit
#define SAEVehicleHeight_Limit_Min                                                      0
#define SAEVehicleHeight_Limit_Max                                                      127

// SAEVehicleLength_Limit
#define SAEVehicleLength_Limit_Min                                                      0
#define SAEVehicleLength_Limit_Max                                                      4095

// SAEVehicleMass_Limit
#define SAEVehicleMass_Limit_Min                                                        0
#define SAEVehicleMass_Limit_Max                                                        255

// SAEVehicleStatusDeviceTypeTag_Limit
#define SAEVehicleStatusDeviceTypeTag_Limit_Min                                         0
#define SAEVehicleStatusDeviceTypeTag_Limit_Max                                         28

// SAEVehicleStatusRequestList_SeqSize
#define SAEVehicleStatusRequestList_SeqSize_Min                                         1
#define SAEVehicleStatusRequestList_SeqSize_Max                                         32

// SAEVehicleStatusRequestSendOnLessThenValue_Limit
#define SAEVehicleStatusRequestSendOnLessThenValue_Limit_Min                            -32767
#define SAEVehicleStatusRequestSendOnLessThenValue_Limit_Max                            32767

// SAEVehicleStatusRequestSendOnMoreThenValue_Limit
#define SAEVehicleStatusRequestSendOnMoreThenValue_Limit_Min                            -32767
#define SAEVehicleStatusRequestSendOnMoreThenValue_Limit_Max                            32767

// SAEVehicleStatusRequestSubType_Limit
#define SAEVehicleStatusRequestSubType_Limit_Min                                        1
#define SAEVehicleStatusRequestSubType_Limit_Max                                        15

// SAEVehicleToLanePositionList_SeqSize
#define SAEVehicleToLanePositionList_SeqSize_Min                                        1
#define SAEVehicleToLanePositionList_SeqSize_Max                                        5

// SAEVehicleType_Limit
#define SAEVehicleType_Limit_Min                                                        0
#define SAEVehicleType_Limit_Max                                                        15

// SAEVehicleWidth_Limit
#define SAEVehicleWidth_Limit_Min                                                       0
#define SAEVehicleWidth_Limit_Max                                                       1023

// SAEVelocity_Limit
#define SAEVelocity_Limit_Min                                                           0
#define SAEVelocity_Limit_Max                                                           8191

// SAEVertOffset_B07_Limit
#define SAEVertOffset_B07_Limit_Min                                                     -64
#define SAEVertOffset_B07_Limit_Max                                                     63

// SAEVertOffset_B08_Limit
#define SAEVertOffset_B08_Limit_Min                                                     -128
#define SAEVertOffset_B08_Limit_Max                                                     127

// SAEVertOffset_B09_Limit
#define SAEVertOffset_B09_Limit_Min                                                     -256
#define SAEVertOffset_B09_Limit_Max                                                     255

// SAEVertOffset_B10_Limit
#define SAEVertOffset_B10_Limit_Min                                                     -512
#define SAEVertOffset_B10_Limit_Max                                                     511

// SAEVertOffset_B11_Limit
#define SAEVertOffset_B11_Limit_Min                                                     -1024
#define SAEVertOffset_B11_Limit_Max                                                     1023

// SAEVertOffset_B12_Limit
#define SAEVertOffset_B12_Limit_Min                                                     -2048
#define SAEVertOffset_B12_Limit_Max                                                     2047

// SAEVerticalAccelerationThreshold
#define SAEVerticalAccelerationThreshold_notEquipped                                    0
#define SAEVerticalAccelerationThreshold_leftFront                                      1
#define SAEVerticalAccelerationThreshold_leftRear                                       2
#define SAEVerticalAccelerationThreshold_rightFront                                     3
#define SAEVerticalAccelerationThreshold_rightRear                                      4
#define SAEVerticalAccelerationThreshold_NumBits                                        5

// SAEVerticalAcceleration_Limit
#define SAEVerticalAcceleration_Limit_Min                                               -127
#define SAEVerticalAcceleration_Limit_Max                                               127

// SAEWheelEndElectFault_Limit
#define SAEWheelEndElectFault_Limit_Min                                                 0
#define SAEWheelEndElectFault_Limit_Max                                                 3

// SAEWheelSensorStatus_Limit
#define SAEWheelSensorStatus_Limit_Min                                                  0
#define SAEWheelSensorStatus_Limit_Max                                                  3

// SAEWiperRate_Limit
#define SAEWiperRate_Limit_Min                                                          0
#define SAEWiperRate_Limit_Max                                                          127

// SAEWiperStatus_Limit
#define SAEWiperStatus_Limit_Min                                                        0
#define SAEWiperStatus_Limit_Max                                                        6

// SAEWorkZone_SeqSize
#define SAEWorkZone_SeqSize_Min                                                         1
#define SAEWorkZone_SeqSize_Max                                                         16

// SAEYawRateConfidence_Limit
#define SAEYawRateConfidence_Limit_Min                                                  0
#define SAEYawRateConfidence_Limit_Max                                                  7

// SAEYawRate_Limit
#define SAEYawRate_Limit_Min                                                            -32767
#define SAEYawRate_Limit_Max                                                            32767

// SAEYear_Limit
#define SAEYear_Limit_Min                                                               1
#define SAEYear_Limit_Max                                                               65535

// SAEZoneLength_Limit
#define SAEZoneLength_Limit_Min                                                         0
#define SAEZoneLength_Limit_Max                                                         10000

// SAEZoom_Limit
#define SAEZoom_Limit_Min                                                               0
#define SAEZoom_Limit_Max                                                               15

#ifdef __cplusplus
}
#endif
